#include "abstractshartitem.h"
#include <QDebug>
#include <QCursor>
#include <QDialog>
#include <QFormLayout>
AbstractShartItem::AbstractShartItem(QObject * parent) :
        QObject(parent),QGraphicsRectItem(0)
{

    setFlags(QGraphicsItem::ItemIsMovable|QGraphicsItem::ItemIsSelectable);
    mIsResizing= false;
    mOldPosition = QPoint(3,3);
    setAcceptedMouseButtons ( Qt::LeftButton|Qt::RightButton );
    setRect(0,0,200,200);



}



void AbstractShartItem::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
                              QWidget *widget)
{

    if ( isSelected())
    {
        QPen pen;
        pen.setWidth(2);
        pen.setColor(Qt::red);
        painter->setPen(pen);
        //    if ( isSelected())
        painter->drawRect(boundingRect().toRect());

        //option handle
        QPixmap iconPix(16,16);
        iconPix.fill(Qt::blue);
        painter->drawPixmap(boundingRect().x(),boundingRect().y(),16,16,iconPix);

        //resize handle
        QPixmap rectPix(16,16);
        rectPix.fill(Qt::green);
        QRect resizeRect(boundingRect().right()-16,boundingRect().bottom()-16,16,16);
        painter->drawPixmap(resizeRect,rectPix);
    }


}
void AbstractShartItem::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
{
    if ( event->button() == Qt::LeftButton)
    {
        setCursor(QCursor(Qt::ArrowCursor));
        setFlags(QGraphicsItem::ItemIsMovable|QGraphicsItem::ItemIsSelectable);
        mIsResizing = false;
    }
    QGraphicsItem::mouseReleaseEvent(event);
}

void AbstractShartItem::mousePressEvent ( QGraphicsSceneMouseEvent * event )
{
    QRect iconRect( boundingRect().x(),boundingRect().y(),16,16);
    if ( iconRect.contains(event->pos().toPoint()))
        emit optionClicked();


    QRect resizeRect(boundingRect().right()-16,boundingRect().bottom()-16,16,16);
    if ( resizeRect.contains(event->pos().toPoint()))
    {

        setCursor(QCursor(Qt::SizeBDiagCursor));
        mIsResizing = true;
        setFlags(QGraphicsItem::ItemIsSelectable);
    }
    QGraphicsItem::mousePressEvent(event);
}
void AbstractShartItem::mouseMoveEvent ( QGraphicsSceneMouseEvent * event )
{
    if ( mIsResizing)
        setRect(rect().x(),rect().y(), event->pos().x(),event->pos().y());
    QGraphicsItem::mouseMoveEvent(event);
}
