#ifndef ABSTRACTTABLEWIDGET_H
#define ABSTRACTTABLEWIDGET_H

#include <QWidget>
#include <QTreeView>
#include <QLineEdit>
#include <QComboBox>
#include <QToolBar>
#include <QSqlQueryModel>
#include <QSortFilterProxyModel>
#include "form/formdialog.h"
#include "form/abstractform.h"
#include "common/sqlhelper.h"
#include "form/formdialog.h"
class AbstractTableWidget : public QWidget
{
    Q_OBJECT
public:
    explicit AbstractTableWidget(QWidget *parent = 0);
void setModel(QSqlQueryModel * model);
QTreeView * treeView(){return mTreeView;}
QSqlRecord firstRecordSelected();
QList<QSqlRecord> recordsSelected();
signals:

public slots:
virtual void addRecord()=0;
virtual void editRecord()=0;
virtual void deleteRecord()=0;
void refresh();
void filterChanged(const QString& filter);
void itemSelected(const QModelIndex &index);
void exportCsv();
private:
    QTreeView * mTreeView;
    QLineEdit * mLineEdit;
    QComboBox * mComboField;
    QToolBar * mToolBar;
    QSortFilterProxyModel * mFilterModel;
    QSqlQueryModel * mQueryModel;

};

#endif // ABSTRACTTABLEWIDGET_H
